//+------------------------------------------------------------------+
//|                                               Candle_NoTrade.mq4 |
//|                                                       Vixen Girl |
//|                                                vixenme@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Vixen Girl"
#property link      "vixenme@gmail.com"

// TimeFrame
extern string     TimeFrameExp = "<<< Murray Math Time Frame Settings >>>";
extern string     TF_note = "1=M1 2=M5 3=M15 4=M30 5=H1 6=H4 7=D1 8=W1 9=MN 0=Chart";
extern int        Indicator_TimeFrame           = 3;

extern string     EntryLine_note = "EntryLine = Line No. from Center Line";
extern int        EntryLine = 3;
extern int        ExitLine = 3;
extern int        P = 64;
extern int        StepBack = 0;
extern int        BarstoDraw = 500;

extern int        OnceinXmin                    = 1;

//MA Settings
string            MAFExp = "<<< MA Filter Settings >>>";
extern bool       MA_Filter = true;
int               MA_Filter_Period = 100;

extern string     OriginalExp = "<<< Original Settings >>>";
extern string     workPeriod                    ="D1";
extern int        SLlevel                       = 100;

extern int        MagicNo                       = 222222222;

extern int        TakeProfit                    = 1800;
extern double     Lots                          = 0.1;
extern int        TrailingStop                  = 38;

extern string     OrdComment                    =  "BarByBar ^_+";

extern color      OpenBuy_Sig_Color             = DarkGoldenrod;
extern color      CloseBuy_Sig_Color            = Black;
extern color      OpenSell_Sig_Color            = Crimson;
extern color      CloseSell_Sig_Color           = Black;
extern color      Modified_Sig_Color            = DarkViolet;

extern bool       Enable_Sound                  = true;
extern string     Sound_OrderOpen_FileName      = "feelgood.wav";
extern string     Sound_OrderClose_FileName     = "jaildoorclose.wav";
extern string     Sound_OrderModify_FileName    = "kiss.wav";

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNo)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
      return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  //----------------------------------------------------------------

//+------------------------------------------------------------------+
//| Txt2Period                                                       |
//+------------------------------------------------------------------+
  int Txt2Period(string text)
  {
      if       (text=="M1"    || text=="m1")int   Prd =1 ;
      else if  (text=="M5"    || text=="m5")      Prd =5 ;
      else if  (text=="M15"   || text=="m15")     Prd =15 ;
      else if  (text=="M30"   || text=="m30")     Prd =30 ;
      else if  (text=="H1"    || text=="h1")      Prd =60 ;
      else if  (text=="H4"    || text=="h4")      Prd =240 ;
      else if  (text=="D1"    || text=="d1")      Prd =1440 ;
      else if  (text=="W1"    || text=="w1")      Prd =10080 ;
      else if  (text=="MN"    || text=="mn")      Prd =43200 ;
      else     /*text==**/                        Prd = 0;
      return(Prd);
  }
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   //----

   if(Minute() % OnceinXmin != 0) return(0);

   int DQADJ = DeciQuoteAdjuster();
   int Ind_TF = TF_Selector(Indicator_TimeFrame);

//---- Defind up-down PART
   int   wrkPeriod   =Txt2Period(workPeriod);

   double high  = iHigh(NULL,wrkPeriod,0);
   double low   = iLow(NULL,wrkPeriod,0);
   double close = iClose(NULL,wrkPeriod,0);
   double open  = iOpen(NULL,wrkPeriod,0);

  //////////////////////////////////////////////////////////////////
  //                                                              //
  //        YOUR OPEN BUY-SELL CONDITION COULD BE HERE            //
  //                                                              //
  //////////////////////////////////////////////////////////////////
   
   //MA Filter
   bool MA_Buy = true; bool MA_Sell = true;
   if(MA_Filter)
   {
      MA_Buy = false; MA_Sell = false;
      if(CALL_Daily_MA(1) > CALL_Daily_MA(2)) MA_Buy = true;
      if(CALL_Daily_MA(1) < CALL_Daily_MA(2)) MA_Sell = true;
   }

   // Buy Condisions
   double Close_1 = iClose(NULL,Ind_TF,1);
   double Close_2 = iClose(NULL,Ind_TF,2);
   string CustomName1 = "Murrey_Math_Line_X_Up"; string CustomName2 = "Murrey_Math_Line_X_Bottom";
   
   bool BUY_SIGNAL = false; bool SELL_SIGNAL = false;
   if( CALL_Custom(Ind_TF, CustomName2, EntryLine, 1) > Close_1 && CALL_Custom(Ind_TF, CustomName2, EntryLine, 2) < Close_2 ) BUY_SIGNAL = true;
   if( CALL_Custom(Ind_TF, CustomName1, EntryLine, 1) < Close_1 && CALL_Custom(Ind_TF, CustomName1, EntryLine, 2) > Close_2 ) SELL_SIGNAL = true;

   //---- Start Trade

   int cnt, ticket, total;
   
   int spread = MathRound((Ask-Bid)/Point);
   bool openenable = true;
      
      for(cnt=0;cnt<HistoryTotal();cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY);
         if(OrderSymbol()==Symbol()&& OrderMagicNumber()==MagicNo)
         {                 
            int lastclosetime = OrderCloseTime();
            
               if(lastclosetime>iTime(Symbol(),wrkPeriod,0))
                        openenable = false;
               else     openenable = true;    
         }
      }
   //+------------------------------------------------------------------+
   //| Don't Trade If Bars<50 & TakeProfit<5 & No Avilable Margin Left  |
   //+------------------------------------------------------------------+
   if(Bars<50)Comment("bars less than ",50);
   else if(TakeProfit<5)Comment("TakeProfit less than ",5);
   else if(AccountFreeMargin()<(1000*Lots))
   {
      Comment("You have no money. Free Margin = ", AccountFreeMargin());
      Print("No money left. Free Margin = ", AccountFreeMargin());
   }
   //+------------------------------------------------------------------+
   else
   {
   //---- Start Trading
      //+--------//Check for opened order in the same symbol//-------------+
      if(CalculateCurrentOrders(Symbol())==0)
      {
         if(openenable)
         {   
            if( BUY_SIGNAL && MA_Buy)
            {
               ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,spread,Ask-SLlevel*DQADJ*Point,Ask+TakeProfit*DQADJ*Point,OrdComment+":"+wrkPeriod,MagicNo,0,OpenBuy_Sig_Color);
            }
            if( SELL_SIGNAL && MA_Sell)
            {  
               ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,spread,Bid+SLlevel*DQADJ*Point,Bid-TakeProfit*DQADJ*Point,OrdComment+":"+wrkPeriod,MagicNo,0,OpenSell_Sig_Color);
            }
         }   
         else ticket=-1;
         
         if(ticket>0)
         {
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
            {
               if (Enable_Sound) PlaySound(Sound_OrderOpen_FileName);
                  Comment("\nAlert : ", TimeToStr(LocalTime(),TIME_MINUTES),"O\'clock",
                           "\nOrder Opened : ",OrderOpenPrice());
                  Print("Order opened : ",OrderOpenPrice());
            return(0);
            }//end OrderSelect
         return(0);
         }//end ticket>0
      return(0);
      }//end of CalculateCurrentOrders()

   //+----------------------------------------------------------------+   
   }//end else (trading)
   
   if(CalculateCurrentOrders(Symbol()) == 0) return(0);

   bool BUY_Exit = false; bool SELL_Exit = false;
   if( CALL_Custom(Ind_TF, CustomName1, ExitLine, 1) < Close_1 && CALL_Custom(Ind_TF, CustomName1, ExitLine, 2) > Close_2 ) BUY_Exit = true;
   if( CALL_Custom(Ind_TF, CustomName2, ExitLine, 1) > Close_1 && CALL_Custom(Ind_TF, CustomName2, ExitLine, 2) < Close_2 ) SELL_Exit = true;
 
   //+--------//Check for closing and modifying condition//-----------+
   total = OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
   {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol()&& OrderMagicNumber()==MagicNo)
      {
         if(OrderType()==OP_BUY) // long position is opening
         {
            // should it be closed?
            if( BUY_Exit )
            {
                     OrderClose(OrderTicket(),OrderLots(),Bid,spread,CloseBuy_Sig_Color);
                     // close position
                     if (Enable_Sound) PlaySound(Sound_OrderClose_FileName);
                     Comment("\nLong Order Closed : ",OrderComment(),
                              "\nAt : ",OrderClosePrice(),
                              "\nProfit : ",OrderProfit(),
                              "\nTime : ", TimeToStr(LocalTime(),TIME_MINUTES));
            return(0); // exit
            }//end closebuy || closebrkbuy
      
            // check for trailing stop
            if(TrailingStop>0)
            {
               if(Bid-OrderOpenPrice()>Point*TrailingStop*DQADJ)
               {
                  if(OrderStopLoss()+(1*Point)<Bid-Point*TrailingStop*DQADJ)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop*DQADJ,OrderTakeProfit(),0,Modified_Sig_Color);
                     if (Enable_Sound) PlaySound(Sound_OrderModify_FileName);
                     Comment("\nOrder Modify Alert : ",TimeToStr(LocalTime(),TIME_MINUTES),
                              "\nNew Stop Loss : ",OrderStopLoss(),
                              "\nNew Target Profit : ",OrderTakeProfit());
                     return(0);
                  }//end OrderStopLoss()<Bid-Point*TrailingStop
               }//end Bid-OrderOpenPrice()>Point*TrailingStop
            }//end TrailingStop>0
         }//end OrderType()==OP_BUY
   
         else // go to short position
         {
            // should it be closed?
            if( SELL_Exit )
            {
            // should it be closed?
                  OrderClose(OrderTicket(),OrderLots(),Ask,spread,CloseSell_Sig_Color);
                  // close position
                  if (Enable_Sound) PlaySound(Sound_OrderClose_FileName);
                  Comment("\nShort Order Closed : ",OrderComment(),
                           "\nAt : ",OrderClosePrice(),
                           "\nProfit : ",OrderProfit(),
                           "\nTime : ", TimeToStr(LocalTime(),TIME_MINUTES));
            return(0); // exit
            }//end closesell || closebrksell

            // check for trailing stop
            if(TrailingStop>0)
            {
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop*DQADJ))
                 {
                  if((OrderStopLoss()-(1*Point)>(Ask+Point*TrailingStop*DQADJ)) || (OrderStopLoss()==0))
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop*DQADJ,OrderTakeProfit(),0,Modified_Sig_Color);
                     if (Enable_Sound) PlaySound(Sound_OrderModify_FileName);
                        Comment("\nOrder Modify Alert : ",TimeToStr(LocalTime(),TIME_MINUTES),
                                 "\nNew Stop Loss : ",OrderStopLoss(),
                                 "\nNew Target Profit : ",OrderTakeProfit());
                  return(0);
                  }//end OrderStopLoss()
               }//end OrderOpenPrice()-Ask >(Point*TrailingStop)
            }//end TrailingStop>0
         }//end else
      }//end OrderType()<=OP_SELL && OrderSymbol()==Symbol()
   }//end for
   //+----------------------------------------------------------------END
 


//+------------------------------------------------------------------+

return(0);
}
//+------------------------------------------------------------------+
   
// *******  Misc  **********************************************************

//+------------------------------------------------------------------+
//| Deci Quote Adjuster                                              | 
//+------------------------------------------------------------------+
int DeciQuoteAdjuster()
{   
   int DeciQuoteADJ = 1;
   // Point Decimal Adjuster -------------------------------
   if(PriceDecimal() == 5 || PriceDecimal() == 3 ) DeciQuoteADJ = 10;

   return(DeciQuoteADJ);
}

//+------------------------------------------------------------------+
//| Price Decimal()                                                  |
//+------------------------------------------------------------------+
double PriceDecimal()
{
   int Decimal = MarketInfo(Symbol(),MODE_DIGITS); // Decimal Adjustment
   return(Decimal);
}

//+------------------------------------------------------------------+
//| TF Selector                                                      |
//+------------------------------------------------------------------+
int TF_Selector(int TIMEFRAME)
{
   int TF;

   // Indicator Time Frame
   switch(TIMEFRAME) // 0=Chart 1=M1 2=M5 3=M15 4=M30 5=1H 6=4H 7=D1 8=W1 9=MN
   {
      case 0 : TF = 0; break; 
      case 1 : TF = 1; break; 
      case 2 : TF = 5; break; 
      case 3 : TF = 15; break; 
      case 4 : TF = 30; break; 
      case 5 : TF = 60; break; 
      case 6 : TF = 240; break; 
      case 7 : TF = 1440; break; 
      case 8 : TF = 10080; break; 
      case 9 : TF = 43200; break; 
      default: TF = 0; break; 
   }

   return(TF);
}

//+------------------------------------------------------------------+
//| CALL Indicator                                                   |
//+------------------------------------------------------------------+
double CALL_Custom(int TIMEFRAME, string CUSTOMNAME, int BUF, int SHIFT)
{
   double IndValue = iCustom(NULL,TIMEFRAME, CUSTOMNAME,
   P,"",Indicator_TimeFrame,StepBack,BarstoDraw,
   BUF,
   SHIFT);
   return(IndValue);
}

//+------------------------------------------------------------------+
//| CALL_Daily_MA                                                    |
//+------------------------------------------------------------------+
double CALL_Daily_MA(int i)
{
   double Ind = iMA(NULL, 1440,MA_Filter_Period,0,MODE_SMA,PRICE_CLOSE,i);

   return(Ind);
}

